git-am.sh 11.0 KB
Newer Older
1 2
#!/bin/sh
#
3
# Copyright (c) 2005, 2006 Junio C Hamano
4

5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
OPTIONS_KEEPDASHDASH=
OPTIONS_SPEC="\
git-am [options] <mbox>|<Maildir>...
git-am [options] --resolved
git-am [options] --skip
--
d,dotest=       use <dir> and not .dotest
i,interactive=  run interactively
b,binary        pass --allo-binary-replacement to git-apply
3,3way          allow fall back on 3way merging if needed
s,signoff       add a Signed-off-by line to the commit message
u,utf8          recode into utf8 (default)
k,keep          pass -k flagg to git-mailinfo
whitespace=     pass it through git-apply
C=              pass it through git-apply
p=              pass it through git-apply
resolvemsg=     override error message when patch failure occurs
r,resolved      to be used after a patch failure
skip            skip the current patch"

25
. git-sh-setup
26
set_reflog_action am
27
require_work_tree
28

29 30
git var GIT_COMMITTER_IDENT >/dev/null || exit

31 32 33 34 35
stop_here () {
    echo "$1" >"$dotest/next"
    exit 1
}

36
stop_here_user_resolve () {
37
    if [ -n "$resolvemsg" ]; then
J
Jeff King 已提交
38
	    printf '%s\n' "$resolvemsg"
39 40
	    stop_here $1
    fi
41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59
    cmdline=$(basename $0)
    if test '' != "$interactive"
    then
        cmdline="$cmdline -i"
    fi
    if test '' != "$threeway"
    then
        cmdline="$cmdline -3"
    fi
    if test '.dotest' != "$dotest"
    then
        cmdline="$cmdline -d=$dotest"
    fi
    echo "When you have resolved this problem run \"$cmdline --resolved\"."
    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."

    stop_here $1
}

60 61 62 63 64 65 66
go_next () {
	rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
		"$dotest/patch" "$dotest/info"
	echo "$next" >"$dotest/next"
	this=$next
}

67 68 69 70 71 72
cannot_fallback () {
	echo "$1"
	echo "Cannot fall back to three-way merge."
	exit 1
}

73 74 75 76 77 78 79
fall_back_3way () {
    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`

    rm -fr "$dotest"/patch-merge-*
    mkdir "$dotest/patch-merge-tmp-dir"

    # First see if the patch records the index info that we can use.
80 81
    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
	"$dotest/patch" &&
82
    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
83
    git write-tree >"$dotest/patch-merge-base+" ||
84
    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
85 86 87

    echo Using index info to reconstruct a base tree...
    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
88
	git apply $binary --cached <"$dotest/patch"
89 90 91
    then
	mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
	mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
92 93 94
    else
        cannot_fallback "Did you hand edit your patch?
It does not apply to blobs recorded in its index."
95 96 97
    fi

    test -f "$dotest/patch-merge-index" &&
98
    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
99 100 101 102 103 104 105 106
    orig_tree=$(cat "$dotest/patch-merge-base") &&
    rm -fr "$dotest"/patch-merge-* || exit 1

    echo Falling back to patching base and 3-way merge...

    # This is not so wrong.  Depending on which base we picked,
    # orig_tree may be wildly different from ours, but his_tree
    # has the same set of wildly different changes in parts the
107
    # patch did not touch, so recursive ends up canceling them,
108 109
    # saying that we reverted all those changes.

110 111 112
    eval GITHEAD_$his_tree='"$SUBJECT"'
    export GITHEAD_$his_tree
    git-merge-recursive $orig_tree -- HEAD $his_tree || {
113
	    git rerere
114 115 116
	    echo Failed to merge in the changes.
	    exit 1
    }
117
    unset GITHEAD_$his_tree
118 119 120
}

prec=4
121 122
dotest=.dotest sign= utf8=t keep= skip= interactive= resolved= binary=
resolvemsg= resume=
M
Michael S. Tsirkin 已提交
123
git_apply_opt=
124

125
while test $# != 0
126 127
do
	case "$1" in
128 129 130 131 132 133
	-i|--interactive)
		interactive=t ;;
	-b|--binary)
		binary=t ;;
	-3|--3way)
		threeway=t ;;
134
	-s|--signoff)
135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153
		sign=t ;;
	-u|--utf8)
		utf8=t ;; # this is now default
	--no-utf8)
		utf8= ;;
	-k|--keep)
		keep=t ;;
	-r|--resolved)
		resolved=t ;;
	--skip)
		skip=t ;;
	-d|--dotest)
		shift; dotest=$1;;
	--resolvemsg)
		shift; resolvemsg=$1 ;;
	--whitespace)
		git_apply_opt="$git_apply_opt $1=$2"; shift ;;
	-C|-p)
		git_apply_opt="$git_apply_opt $1$2"; shift ;;
154
	--)
155
		shift; break ;;
156
	*)
157
		usage ;;
158
	esac
159
	shift
160 161
done

J
Junio C Hamano 已提交
162 163
# If the dotest directory exists, but we have finished applying all the
# patches in them, clear it out.
164 165 166 167 168 169 170 171 172 173 174
if test -d "$dotest" &&
   last=$(cat "$dotest/last") &&
   next=$(cat "$dotest/next") &&
   test $# != 0 &&
   test "$next" -gt "$last"
then
   rm -fr "$dotest"
fi

if test -d "$dotest"
then
J
Junio C Hamano 已提交
175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193
	case "$#,$skip$resolved" in
	0,*t*)
		# Explicit resume command and we do not have file, so
		# we are happy.
		: ;;
	0,)
		# No file input but without resume parameters; catch
		# user error to feed us a patch from standard input
		# when there is already .dotest.  This is somewhat
		# unreliable -- stdin could be /dev/null for example
		# and the caller did not intend to feed us a patch but
		# wanted to continue unattended.
		tty -s
		;;
	*)
		false
		;;
	esac ||
	die "previous dotest directory $dotest still exists but mbox given."
194
	resume=yes
195
else
J
Junio C Hamano 已提交
196 197
	# Make sure we are not given --skip nor --resolved
	test ",$skip,$resolved," = ,,, ||
198
		die "Resolve operation not in progress, we are not resuming."
199 200 201 202

	# Start afresh.
	mkdir -p "$dotest" || exit

203
	git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
204 205 206 207
		rm -fr "$dotest"
		exit 1
	}

J
Junio C Hamano 已提交
208 209
	# -b, -s, -u, -k and --whitespace flags are kept for the
	# resuming session after a patch failure.
J
Junio C Hamano 已提交
210
	# -3 and -i can and must be given when resuming.
211
	echo "$binary" >"$dotest/binary"
J
Junio C Hamano 已提交
212
	echo " $ws" >"$dotest/whitespace"
213 214 215 216 217 218
	echo "$sign" >"$dotest/sign"
	echo "$utf8" >"$dotest/utf8"
	echo "$keep" >"$dotest/keep"
	echo 1 >"$dotest/next"
fi

J
Junio C Hamano 已提交
219 220
case "$resolved" in
'')
221
	files=$(git diff-index --cached --name-only HEAD) || exit
J
Junio C Hamano 已提交
222 223 224 225 226 227
	if [ "$files" ]; then
	   echo "Dirty index: cannot apply patches (dirty: $files)" >&2
	   exit 1
	fi
esac

228 229 230 231
if test "$(cat "$dotest/binary")" = t
then
	binary=--allow-binary-replacement
fi
232 233 234
if test "$(cat "$dotest/utf8")" = t
then
	utf8=-u
235 236
else
	utf8=-n
237 238 239 240 241
fi
if test "$(cat "$dotest/keep")" = t
then
	keep=-k
fi
J
Junio C Hamano 已提交
242
ws=`cat "$dotest/whitespace"`
243 244 245 246 247 248 249 250 251 252 253 254 255 256
if test "$(cat "$dotest/sign")" = t
then
	SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
			s/>.*/>/
			s/^/Signed-off-by: /'
		`
else
	SIGNOFF=
fi

last=`cat "$dotest/last"`
this=`cat "$dotest/next"`
if test "$skip" = t
then
257
	git rerere clear
258
	this=`expr "$this" + 1`
J
Jan Harkes 已提交
259
	resume=
260 261 262 263 264 265 266 267 268 269 270 271 272 273
fi

if test "$this" -gt "$last"
then
	echo Nothing to do.
	rm -fr "$dotest"
	exit
fi

while test "$this" -le "$last"
do
	msgnum=`printf "%0${prec}d" $this`
	next=`expr "$this" + 1`
	test -f "$dotest/$msgnum" || {
J
Jan Harkes 已提交
274
		resume=
275 276 277
		go_next
		continue
	}
J
Junio C Hamano 已提交
278 279 280 281 282 283 284 285 286

	# If we are not resuming, parse and extract the patch information
	# into separate files:
	#  - info records the authorship and title
	#  - msg is the rest of commit log message
	#  - patch is the patch body.
	#
	# When we are resuming, these files are either already prepared
	# by the user, or the user can tell us to do so by --resolved flag.
287 288
	case "$resume" in
	'')
289
		git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
290 291
			<"$dotest/$msgnum" >"$dotest/info" ||
			stop_here $this
292 293 294 295 296 297

		# skip pine's internal folder data
		grep '^Author: Mail System Internal Data$' \
			<"$dotest"/info >/dev/null &&
			go_next && continue

298
		test -s $dotest/patch || {
299
			echo "Patch is empty.  Was it split wrong?"
300 301
			stop_here $this
		}
302
		git stripspace < "$dotest/msg" > "$dotest/msg-clean"
303 304
		;;
	esac
305 306 307 308

	GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
	GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
	GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
309 310 311 312 313 314 315

	if test -z "$GIT_AUTHOR_EMAIL"
	then
		echo "Patch does not have a valid e-mail address."
		stop_here $this
	fi

J
Junio C Hamano 已提交
316
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
317

318
	SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
319
	case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
320 321 322 323 324

	case "$resume" in
	'')
	    if test '' != "$SIGNOFF"
	    then
325
		LAST_SIGNED_OFF_BY=`
326 327 328
		    sed -ne '/^Signed-off-by: /p' \
		    "$dotest/msg-clean" |
		    tail -n 1
329
		`
330 331
		ADD_SIGNOFF=`
		    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
332 333
		    test '' = "$LAST_SIGNED_OFF_BY" && echo
		    echo "$SIGNOFF"
334 335
		}`
	    else
336
		ADD_SIGNOFF=
337 338
	    fi
	    {
339
		printf '%s\n' "$SUBJECT"
340 341 342 343 344 345 346 347 348
		if test -s "$dotest/msg-clean"
		then
			echo
			cat "$dotest/msg-clean"
		fi
		if test '' != "$ADD_SIGNOFF"
		then
			echo "$ADD_SIGNOFF"
		fi
349 350
	    } >"$dotest/final-commit"
	    ;;
J
Junio C Hamano 已提交
351
	*)
352
		case "$resolved$interactive" in
J
Junio C Hamano 已提交
353 354
		tt)
			# This is used only for interactive view option.
355
			git diff-index -p --cached HEAD >"$dotest/patch"
J
Junio C Hamano 已提交
356 357
			;;
		esac
358
	esac
359

360
	resume=
361 362
	if test "$interactive" = t
	then
363 364
	    test -t 0 ||
	    die "cannot be interactive without stdin connected to a terminal."
365 366 367 368 369 370 371
	    action=again
	    while test "$action" = again
	    do
		echo "Commit Body is:"
		echo "--------------------------"
		cat "$dotest/final-commit"
		echo "--------------------------"
J
Jason Riedy 已提交
372
		printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
373 374
		read reply
		case "$reply" in
375 376 377
		[yY]*) action=yes ;;
		[aA]*) action=yes interactive= ;;
		[nN]*) action=skip ;;
378
		[eE]*) git_editor "$dotest/final-commit"
379
		       action=again ;;
380 381 382
		[vV]*) action=again
		       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
		*)     action=again ;;
383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400
		esac
	    done
	else
	    action=yes
	fi

	if test $action = skip
	then
		go_next
		continue
	fi

	if test -x "$GIT_DIR"/hooks/applypatch-msg
	then
		"$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
		stop_here $this
	fi

401
	printf 'Applying %s\n' "$SUBJECT"
402

J
Junio C Hamano 已提交
403 404
	case "$resolved" in
	'')
405
		git apply $git_apply_opt $binary --index "$dotest/patch"
J
Junio C Hamano 已提交
406 407 408 409 410 411 412 413
		apply_status=$?
		;;
	t)
		# Resolved means the user did all the hard work, and
		# we do not have to do any patch application.  Just
		# trust what the user has in the index file and the
		# working tree.
		resolved=
414
		git diff-index --quiet --cached HEAD && {
415
			echo "No changes - did you forget to use 'git add'?"
416
			stop_here_user_resolve $this
417
		}
418
		unmerged=$(git ls-files -u)
419 420 421
		if test -n "$unmerged"
		then
			echo "You still have unmerged paths in your index"
422
			echo "did you forget to use 'git add'?"
423
			stop_here_user_resolve $this
424
		fi
J
Junio C Hamano 已提交
425
		apply_status=0
426
		git rerere
J
Junio C Hamano 已提交
427 428 429
		;;
	esac

430 431
	if test $apply_status = 1 && test "$threeway" = t
	then
432
		if (fall_back_3way)
433
		then
434 435
		    # Applying the patch to an earlier tree and merging the
		    # result may have produced the same tree as ours.
436
		    git diff-index --quiet --cached HEAD && {
437 438 439 440
			echo No changes -- Patch already applied.
			go_next
			continue
		    }
441 442
		    # clear apply_status -- we have successfully merged.
		    apply_status=0
443 444 445 446 447
		fi
	fi
	if test $apply_status != 0
	then
		echo Patch failed at $msgnum.
448
		stop_here_user_resolve $this
449 450 451 452 453 454 455
	fi

	if test -x "$GIT_DIR"/hooks/pre-applypatch
	then
		"$GIT_DIR"/hooks/pre-applypatch || stop_here $this
	fi

456 457 458 459
	tree=$(git write-tree) &&
	parent=$(git rev-parse --verify HEAD) &&
	commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
	git update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
460 461 462 463 464 465 466
	stop_here $this

	if test -x "$GIT_DIR"/hooks/post-applypatch
	then
		"$GIT_DIR"/hooks/post-applypatch
	fi

467 468
	git gc --auto

469 470 471 472
	go_next
done

rm -fr "$dotest"